#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import Image, ImageDraw, ImageFont

#Les espaces dans les noms de fichier, c'est le mal
TICKET_SOURCE = "./ticket_conso_vierge.png"
PREFIXE_FICHIER_PLANCHE_TICKETS = "planche_tickets"
NB_TICKETS_LARGEUR = 6
NB_TICKETS_HAUTEUR = 10

PAGE_LARGEUR = 2480
PAGE_HAUTEUR = 3508

POSITION_TEXTE_TALON_X = 440
POSITION_TEXTE_TALON_Y = 220

POSITION_TEXTE_TICKET_X = 2230
POSITION_TEXTE_TICKET_Y = 165

TAILLE_TEXTE = 90
CHEMIN_POLICE_TEXTE = "/usr/share/fonts/truetype/freefont/FreeSansBold.ttf"

EXTENSION_FICHIERS_FINAUX = ".jpg"

if not os.path.isfile(TICKET_SOURCE):
   print "Fichier " + TICKET_SOURCE +" introuvable"
   exit()

print "Chargement de l'image..."
IMAGE_TICKET_SOURCE = Image.open(TICKET_SOURCE)
IMAGE_TICKET_SOURCE.load()

TICKET_LARGEUR,TICKET_HAUTEUR = IMAGE_TICKET_SOURCE.size

print "Mise à l'échelle du fichier source..."
TICKET_REDIM_LARGEUR = PAGE_LARGEUR/NB_TICKETS_LARGEUR
TICKET_REDIM_HAUTEUR = PAGE_HAUTEUR/NB_TICKETS_HAUTEUR
IMAGE_TICKET_REDIM = IMAGE_TICKET_SOURCE.resize((TICKET_REDIM_LARGEUR, TICKET_REDIM_HAUTEUR))

#if TICKET_REDIM_HAUTEUR*10 > PAGE_HAUTEUR :
#   print "Dimension de la prévente incompatible avec le format de page et le nombre de préventes"
#   exit

print "Assemblage des images..."
IMAGE_TICKETS = Image.new("RGB", (PAGE_LARGEUR, PAGE_HAUTEUR), "#FFFFFF")
INDEX_TICKET_HAUTEUR = 0
while INDEX_TICKET_HAUTEUR < NB_TICKETS_HAUTEUR:
   INDEX_TICKET_LARGEUR = 0
   while INDEX_TICKET_LARGEUR < NB_TICKETS_LARGEUR:
      IMAGE_TICKETS.paste(IMAGE_TICKET_REDIM, (TICKET_REDIM_LARGEUR*INDEX_TICKET_LARGEUR, TICKET_REDIM_HAUTEUR*INDEX_TICKET_HAUTEUR))
      INDEX_TICKET_LARGEUR = INDEX_TICKET_LARGEUR + 1
   INDEX_TICKET_HAUTEUR = INDEX_TICKET_HAUTEUR + 1

print "Sauvegarde de l'image"
IMAGE_TICKETS.save(PREFIXE_FICHIER_PLANCHE_TICKETS + EXTENSION_FICHIERS_FINAUX)

